package com.tomwheeler.example.dogfilesupport.nb.viewer;

import com.tomwheeler.example.dogfilesupport.Dog.Breed;
import com.tomwheeler.example.dogfilesupport.Dog.Sex;

/**
 * <p>
 * This class represents a Swing GUI component that displays specific properties
 * of a Dog object in the NetBeans platform.  This component should be instantiated 
 * and attached to a TopComponent (that passes in a Dog instance) to be used in the
 * NetBeans framework.
 * </p>
 *
 * @author Tom Wheeler
 */
public class DogViewerPanel extends javax.swing.JPanel {
    
    /** Creates new form DogViewerPanel */
    public DogViewerPanel() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        nameLabel = new javax.swing.JLabel();
        ageLabel = new javax.swing.JLabel();
        sexLabel = new javax.swing.JLabel();
        breedLabel = new javax.swing.JLabel();
        playsFetchLabel = new javax.swing.JLabel();
        nameValue = new javax.swing.JLabel();
        ageValue = new javax.swing.JLabel();
        sexValue = new javax.swing.JLabel();
        breedValue = new javax.swing.JLabel();
        playsFetchValue = new javax.swing.JLabel();
        headingLabel = new javax.swing.JLabel();

        nameLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        nameLabel.setText("Name:");

        ageLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        ageLabel.setText("Age:");

        sexLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        sexLabel.setText("Sex:");

        breedLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        breedLabel.setText("Breed:");

        playsFetchLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        playsFetchLabel.setText("Plays Fetch:");

        headingLabel.setFont(new java.awt.Font("Tahoma", 1, 14));
        headingLabel.setText("Dog File Viewer");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, headingLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(nameLabel)
                            .add(ageLabel)
                            .add(sexLabel)
                            .add(breedLabel)
                            .add(playsFetchLabel))
                        .add(29, 29, 29)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(playsFetchValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(breedValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(sexValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(ageValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(nameValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 255, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(39, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(headingLabel)
                .add(25, 25, 25)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(nameValue)
                    .add(nameLabel))
                .add(21, 21, 21)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(ageLabel)
                    .add(ageValue))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(sexLabel)
                    .add(sexValue))
                .add(17, 17, 17)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(breedLabel)
                    .add(breedValue))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(playsFetchLabel)
                    .add(playsFetchValue))
                .addContainerGap(102, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel ageLabel;
    private javax.swing.JLabel ageValue;
    private javax.swing.JLabel breedLabel;
    private javax.swing.JLabel breedValue;
    private javax.swing.JLabel headingLabel;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JLabel nameValue;
    private javax.swing.JLabel playsFetchLabel;
    private javax.swing.JLabel playsFetchValue;
    private javax.swing.JLabel sexLabel;
    private javax.swing.JLabel sexValue;
    // End of variables declaration//GEN-END:variables

    // everything is read-only, so we don't need getter methods.
    // this is meant to be a pure view component, devoid of any logic, so 
    // any translation to Strings happens in the calling code.
    protected void setNameValue(String nameValueText) {
        nameValue.setText(nameValueText);
    }
    
    protected void setAgeValue(String ageValueText) {
        ageValue.setText(ageValueText);
    }
    
    protected void setSexValue(String sexValueText) {
        sexValue.setText(sexValueText);
    }
    
    protected void setBreedValue(String breedValueText) {
        breedValue.setText(breedValueText);
    }
    
    protected void setPlaysFetchValue(String playsFetchValueText) {
        playsFetchValue.setText(playsFetchValueText);
    }
}
